<?php defined('SYSPATH') or die('No direct script access.');

abstract class SortingOptions { //extends SplEnum {  // todo: think about usage & file system
    //const __default = self::Name;

    const Name = 0;
    const Grade = 1;
    const Group = 2;
}

class Controller_Handler_AdmStudents extends Controller_Handler
{
    const STUDENTS_LIST = '/handler/listOutput';
    
        public function before() {
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }

        public function action_createStudent()
        {
            $response['success'] = false;
            $this->post
                    ->rule('firstName', 'not_empty')
                    // ->rule('firstName', 'alpha_dash', array(':value', TRUE))
                    // ->rule('secondName', 'not_empty')
                    // ->rule('secondName', 'alpha_dash', array(':value', TRUE))
                    ->rule('lastName', 'not_empty')
                    // ->rule('lastName', 'alpha_dash', array(':value', TRUE))
                    ->rule('gradeNum', 'not_empty')
                    ->rule('gradeNum', 'digit')
                    ->rule('groupNum', 'not_empty')
                    ->rule('groupNum', 'digit')
                    ->rule('facultyID', 'not_empty')
                    ->rule('facultyID', 'digit');
            if($this->post['gradeNum'] == 0)
            {
                $this->post->error('gradeNum', 'not_empty');
                $response['success'] = false;
            }
            if($this->post['groupNum'] == 0)
            {
                $this->post->error('groupNum', 'not_empty');
                $response['success'] = false;
            }
            if($this->post['facultyID'] == 0)
            {
                $this->post->error('facultyID', 'not_empty');
                $response['success'] = false;
            }
            if($this->post->check())
            {
                $code = Account::instance()
                    ->createStudent(
                        $this->post['lastName'],
                        $this->post['firstName'],
                        $this->post['secondName'],
                        $this->post['gradeNum'],
                        $this->post['groupNum'],
                        $this->post['facultyID']
                    );

                if($code != -1)
                {
                    $response['success'] = true;
                    $response['code'] = $code;
                }
                else {
                    $response['success'] = false;
                }
            }
            else
            {
                $response['success'] = false;
                $response['messages'] = $this->post->errors();
            }
            $this->response->body(json_encode($response));
        }
        
        public function action_getGroups()
        {
            $facultyID = $this->post['facultyID'];
            $gradeID = $this->post['gradeNum'];
            if(($facultyID && $gradeID) != 0)
            {
                $groups = Model_Faculty::with($facultyID)->getGroups($gradeID);
                $groupsHandled = array(); $i = $j = $id = 0;
                foreach($groups as $row)
                {
                    if($id != $row['SpecID'])
                    {
                        $i++; $j = 0;
                        $id = $row['SpecID'];
                    }
                    $j++;
                    if (is_null($row['SpecName'])) 
                    	$groupsHandled[$i]['SpecName'] = "<без специализации>";
                    else
                    	$groupsHandled[$i]['SpecName'] = $row['SpecName'];
                    $groupsHandled[$i]['Groups'][$j]['ID'] = $row['ID'];
                    $groupsHandled[$i]['Groups'][$j]['Num'] = $row['GroupNum'];
                }
                $this->response->body(json_encode($groupsHandled));
            }
        }

        public function action_getStudentsList($option = SortingOptions::Name) {
            $twig = Twig::factory(self::STUDENTS_LIST);

            $facultyID = (int) $this->post['facultyID'];
            $gradeID = (int) $this->post['gradeID'];
            $groupID = (int) $this->post['groupID'];

            if ($this->post->check()) {
                $result = Model_Students::byFaculty($facultyID , $gradeID, $groupID);
                    $twig->List = $result;
            }

            $this->response->body($twig);
        }

        public function action_getStudentsByStudyGroup()
        {
            $groupID = $this->post['studyGroupID'];
            if($groupID != 0)
            {
                $twig = Twig::factory(self::STUDENTS_LIST);
                $twig->List = Model_Students::byStudyGroup($groupID);
                $this->response->body($twig);           
            }
        }

        /** @deprecated */
        public function action_getStudentsByFaculty()
        {
            $facultyID = $this->post['facultyID'];
            if($facultyID != 0)
            {
                $twig = Twig::factory(self::STUDENTS_LIST);
                // (Grade, Group) = (0,0), to ignore (search all students)
                $twig->List = Model_Students::byFaculty($facultyID, 0, 0);
                $this->response->body($twig);           
            }
        }

    public function action_getStudentsByName() {
        $twig = Twig::factory(self::STUDENTS_LIST);

        $facultyID = (int) $this->post['facultyID'];
        $gradeID = (int) $this->post['gradeID'];
        $groupID = (int) $this->post['groupID'];
        $name = $this->post['name'];

        if (strlen($name) >= 3) {
            $twig->List = Model_Students::searchStudentsByName($name, $facultyID, $gradeID, $groupID);
        }

        $this->response->body($twig);
    }

    public function action_giveLeave() {
        // fixme
        $id = (int) $this->get['id'];
        Model_Student::load($id)
            ->toAcademicLeave();
    }

    public function action_stopLeave() {
        // fixme
        $id = (int) $this->get['id'];
        //Model_Student::load($id)
        //    ->attach()
    }
}